<!DOCTYPE html>
<html lang="en">
<head>
  <title>Task 66 Ward CRUD</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Ward</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
			<label for="ward-name">Tên Ward</label>
		</div>
		<div class="col-sm-9">
			<input type="text" id="input-ward-name" name="ward-name" placeholder="Ward name" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="ward-prefix">Prefix</label>
		</div>
		<div class="col-sm-9">
		  <select id="select-ward-prefix" name="ward-prefix" class="form-control">
			<option value="Xã">Xã</option>
			<option value="Phường">Phường</option>
			<option value="Thị trấn">Thị trấn</option>
		  </select>
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="province-name">Tên Province</label>
		</div>
		<div class="col-sm-9">
		  <select id="select-province" name="province-name" class="form-control">
		  </select>
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="district-name">Tên District</label>
		</div>
		<div class="col-sm-9">
		  <select id="select-district" name="district-name" class="form-control">
		  </select>
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="add_data" class="btn btn-success mr-3">Add Data</button>
		  <button id="update_data" class="btn btn-info mr-3">Update Data</button>
		  <button id="delete_data" class="btn btn-warning mr-3">Delete Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>Id</th>
        <th>Tên Ward</th>
		<th>Prefix</th>
		<th>Province Id</th>
		<th>District Id</th>
      </tr>
  </table>
</div>
<script>
	$(document).ready(function(){
		var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"name"},
				{"data":"prefix"},
				{"data":"provinceId"},
				{"data":"districtId"}
			]
		})

		callAjaxApiGetAllProvinces();

		function callAjaxApiGetAllProvinces() {
			$.ajax({
				url: "http://localhost:8080/province/all",
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadDataToProvinceSelect(res);
				},
				error: function(err) {
					console.log(err.response);
				}
			})
		}

		function loadDataToProvinceSelect(pProvinceList) {
			for (i = 0; i < pProvinceList.length; i++) {
				var bProvinceOption = $("<option/>");
				bProvinceOption.prop("value", pProvinceList[i].id);
				bProvinceOption.prop("text", pProvinceList[i].name + ", " + pProvinceList[i].code);
				$("#select-province").append(bProvinceOption);
			};
		}

		$("#select-province").on("change", function () {
			$("#select-district").html("");
			var vProvinceId = $(this).val();
			console.log("Đã chọn province có id là: " + vProvinceId);
			callAjaxApiGetDistrictsByProvinceId(vProvinceId);
		});

		function callAjaxApiGetDistrictsByProvinceId(paramProvinceId) {
			$.ajax({
				url: "http://localhost:8080/district/all/provinceId/" + paramProvinceId,
				type: "GET",
				async: false,
				dataType: "json",
				success: function(res) {
					loadDataToDistrictSelect(res);
				},
				error: function(err) {
					console.log(err.response);
				}
			})
		}

		function loadDataToDistrictSelect(pDistrictList) {
			for (i = 0; i < pDistrictList.length; i++) {
				var bDistrictOption = $("<option/>");
				bDistrictOption.prop("value", pDistrictList[i].id);
				bDistrictOption.prop("text", pDistrictList[i].prefix + ", " + pDistrictList[i].name);
				$("#select-district").append(bDistrictOption);
			};
		}

		var gBaseUrl = "http://localhost:8080/ward";

		callAjaxApiGetAllWards();

		function callAjaxApiGetAllWards() {
			$.ajax({
				url: gBaseUrl + "/all",
				type: "GET",
				async: false,
				dataType: "json",
				success: function(res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function(err) {
					console.log(err.response);
				}
			})
		}
		
		// khi click vào 1 row trong danh sách, sẽ load dữ liệu vào form, bằng cách gọi API (GET)
		$("#user-table").on("click", "td", function() {
			onTableRowClick(this);
		});

		var gSelectedId = 0;

		function onTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = table.row(vClickedRow).data();
			gSelectedId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gSelectedId);
			callAjaxApiGetWardById(gSelectedId);
		}

		function callAjaxApiGetWardById(paramId) {
			$.ajax({
				url: gBaseUrl + "/detail/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadWardDataToForm(res);
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}

		function loadWardDataToForm(paramWard) {
			$("#input-ward-name").val(paramWard.name);
			$("#select-ward-prefix").val(paramWard.prefix);
			$("#select-province").val(paramWard.provinceId);
			$("#select-district").html("");
			callAjaxApiGetDistrictsByProvinceId(paramWard.provinceId);
			$("#select-district").val(paramWard.districtId);
		}

		$("#update_data").on("click", function() {
			if(gSelectedId == 0) {
				alert("Chưa chọn Ward nào");
			}
			else {
				var vWardData = readWardDataFromWeb();
				callAjaxApiUpdateWardById(gSelectedId, vWardData);
			}
		})

		function readWardDataFromWeb() {
			var vWardData = {
				prefix: $("#select-ward-prefix").val(),
				name: $("#input-ward-name").val(),
			};			
			console.log("Thông tin Ward đọc được là:");
			console.log(vWardData);
			return vWardData
		}

		function callAjaxApiUpdateWardById(paramId, paramWardData) {
			$.ajax({
				url: gBaseUrl + "/update/" + paramId,
				type: "PUT",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramWardData),
				success: function(res) {
					callAjaxApiGetAllWards();
					console.log("Update thành công cho Ward có id " + paramId + ". Response là:");
					console.log(res);
					setTimeout(function(){
						alert("Update thành công cho Ward có id " + paramId)}, 1000);
				},
				error: function(err){
					console.log(err.response);
					alert("Update không thành công. Xem console");
				}
			})
		}

		$("#add_data").on("click", function() {
			gSelectedId = 0;
			var vWardData = readWardDataFromWeb();
			var vDistrictId = $("#select-district").val();
			callAjaxApiAddNewWard(vDistrictId, vWardData);
		})

		function callAjaxApiAddNewWard(paramDistrictId, paramWardData) {
			$.ajax({
				url: gBaseUrl + "/create?districtId=" + paramDistrictId,
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(paramWardData),
				success: function(res) {
					callAjaxApiGetAllWards();
					gSelectedId = res.id;
					console.log("Tạo Ward mới thành công. Response là:");
					console.log(res);
					setTimeout(function(){
						alert("Tạo Ward mới thành công! Id mới là: " + res.id)}, 1000);
				},
				error: function(err){
					console.log(err.response);
					alert("Tạo Ward mới không thành công! Xem console");
				}
			})
		}

		$("#delete_data").on("click", function() {
			if(gSelectedId == 0) {
				alert("Chưa chọn Ward nào");
			}
			else {
				var vConfirmDelete = confirm("Xóa Ward có id " + gSelectedId + "?");
				if(vConfirmDelete == true) {
					callAjaxApiDeleteWardById(gSelectedId);
				}
			}
		})

		function callAjaxApiDeleteWardById(paramWardId) {
			$.ajax({
				url: gBaseUrl + "/delete/" + paramWardId,
				type: "DELETE",
				dataType: "json",
				success: function(res) {
					gSelectedId = 0;
					callAjaxApiGetAllWards();
					console.log("Xóa Ward có id " + paramWardId + " thành công. Response là:");
					console.log(res);
					setTimeout(function(){
						alert("Xóa Ward có id " + paramWardId + " thành công!")}, 1000);
				},
				error: function(err){
					console.log(err.response);
					alert("Xóa Ward có id " + paramWardId + " không thành công!");
				}
			})
		}
	})
</script>
</body>
</html>
